
#include <qapp.h>
#include <yafAmplifier/yafAmplifier.h>
#include <devices/genericStreamProducer.h>
#include <devices/audioDeviceLinux.h>
#include <devices/realTimeAudioDevice.h>
#include <devices/mixerDevice.h>

#include <unistd.h>

#include "guiPlayer6.h"


/**
   This example show how to implement mixing of streams
   The device changes the volume of the PCM stream _in software!_
   (time consuming)
   The mixer stores the streams and then mix them and sends
   them to the audiodevice
   (more time consuming)

   Make sure youe have edited the file

   ../mp3Songs.h


*/



#include "../SONGS.DEF"




int main(int nargs,char** args) {
  QApplication a( nargs, args);


  YafAmplifier* amplifier;
  GenericStreamProducer* decoder1;
  GenericStreamProducer* decoder2;
  OutputDevice* audioDevice;
  MixerDevice* mixer=new MixerDevice();

  AudioDeviceLinux* audioDeviceL=new AudioDeviceLinux("/dev/dsp",true);
   
  audioDevice=audioDeviceL;

  audioDevice->openDevice();
  amplifier=new YafAmplifier();

  decoder1=amplifier->createDecoder(_MP3_DECODER);
  decoder2=amplifier->createDecoder(_MP3_DECODER);


  // here the gui part: (1st player)
  GuiPlayer w;
  w.setGeometry( 100, 100, 750, 150 );
  w.show();
  w.setGenericStreamProducer(decoder1);
  w.open(song[2]);
  

  // and the second player

  GuiPlayer w1;
  w1.setGeometry( 100, 280, 750, 150 );
  w1.setGenericStreamProducer(decoder2);
  w1.open(song[1]);
  w1.show();



  // now setup the mixer

  w.addListener(mixer);
  w1.addListener(mixer);
  
  mixer->addListener(audioDevice);


  // now start the whole thing
  a.setMainWidget( &w );
  a.exec();
  delete audioDevice;
  delete decoder1;
  delete decoder2;

  return 0;
}



  
